﻿Module Module1

    Private mastrCustRec() As String
    Private mstrMenuChoice As String

    Sub Main()

        ShowMenu()

        Do
            Select Case mstrMenuChoice
                Case "1"
                    DisplayCustInfo("L")
                Case "2"
                    DisplayCustInfo("S")
                Case "3"
                    End
                Case Else
                    Console.WriteLine()
                    Console.Write("INVALID CHOICE. Enter the number corresponding to your selection: ")
                    mstrMenuChoice = Console.ReadLine
            End Select

        Loop

    End Sub

    Private Sub ShowMenu()

        Console.Clear()
        Console.WriteLine("*** SORT RECORD DEMO ***")
        Console.WriteLine()
        Console.WriteLine("Select an item from the list below:")
        Console.WriteLine()
        Console.WriteLine("1. Sort Customer File by Last Name")
        Console.WriteLine("2. Sort Customer File by State and Last Name")
        Console.WriteLine("3. Exit")

        Console.WriteLine()
        Console.Write("Enter the number corresponding to your selection: ")
        mstrMenuChoice = Console.ReadLine

    End Sub

    Private Sub DisplayCustInfo(ByRef pstrSortType As String)

        Dim strCustFileName As String
        Dim intCustFileNbr As Integer
        Dim intX As Integer
        Dim intArrX As Integer

        Dim strLastName As String
        Dim strFirstName As String
        Dim strAddr As String
        Dim strCity As String
        Dim strState As String
        Dim strZip As String
        Dim strFixedRec As String

        strCustFileName = My.Application.Info.DirectoryPath & "\CustTest.txt"
        intCustFileNbr = FreeFile()

        FileOpen(intCustFileNbr, strCustFileName, OpenMode.Input)

        intArrX = -1

        Do Until EOF(intCustFileNbr)
            Input(intCustFileNbr, strLastName)
            Input(intCustFileNbr, strFirstName)
            Input(intCustFileNbr, strAddr)
            Input(intCustFileNbr, strCity)
            Input(intCustFileNbr, strState)
            Input(intCustFileNbr, strZip)
            strFixedRec = ""
            If pstrSortType = "L" Then
                strFixedRec = strLastName.PadRight(20)
            Else
                strFixedRec = (strState & strLastName).PadRight(20)
            End If
            strFixedRec &= strLastName.PadRight(15) _
                        & strFirstName.PadRight(15) _
                        & strCity.PadRight(25) _
                        & strState
            intArrX += 1
            ReDim Preserve mastrCustRec(intArrX)
            mastrCustRec(intArrX) = strFixedRec
        Loop

        FileClose(intCustFileNbr)

        Array.Sort(mastrCustRec)

        Console.Clear()

        Console.WriteLine("CUSTOMER FILE SORTED BY " & IIf(pstrSortType = "L", "LAST NAME", "STATE AND LAST NAME"))
        Console.WriteLine()
        Console.WriteLine("LAST NAME      FIRST NAME     CITY                     STATE")
        Console.WriteLine("---------      ----------     ----                     -----")
        For intX = 0 To UBound(mastrCustRec)
            Console.WriteLine(Mid(mastrCustRec(intX), 21))
        Next
        Console.WriteLine()
        Console.WriteLine("Press Enter to Return to the Menu")
        Console.ReadLine()
        ShowMenu()

    End Sub

End Module
